// Code generated by mockery v2.10.2. DO NOT EDIT.

package mocks

import (
	models "bots-ms/models"

	mock "github.com/stretchr/testify/mock"

	ms_sharedmodels "gitlab.com/nikita.morozov/ms-shared/models"
)

// StateMachineUsecase is an autogenerated mock type for the StateMachineUsecase type
type StateMachineUsecase struct {
	mock.Mock
}

// Count provides a mock function with given fields:
func (_m *StateMachineUsecase) Count() (uint64, error) {
	ret := _m.Called()

	var r0 uint64
	if rf, ok := ret.Get(0).(func() uint64); ok {
		r0 = rf()
	} else {
		r0 = ret.Get(0).(uint64)
	}

	var r1 error
	if rf, ok := ret.Get(1).(func() error); ok {
		r1 = rf()
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// Create provides a mock function with given fields: item
func (_m *StateMachineUsecase) Create(item *models.StateMachine) error {
	ret := _m.Called(item)

	var r0 error
	if rf, ok := ret.Get(0).(func(*models.StateMachine) error); ok {
		r0 = rf(item)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// Delete provides a mock function with given fields: id
func (_m *StateMachineUsecase) Delete(id uint) error {
	ret := _m.Called(id)

	var r0 error
	if rf, ok := ret.Get(0).(func(uint) error); ok {
		r0 = rf(id)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// Get provides a mock function with given fields: id
func (_m *StateMachineUsecase) Get(id uint) (*models.StateMachine, error) {
	ret := _m.Called(id)

	var r0 *models.StateMachine
	if rf, ok := ret.Get(0).(func(uint) *models.StateMachine); ok {
		r0 = rf(id)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.StateMachine)
		}
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(uint) error); ok {
		r1 = rf(id)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetByBot provides a mock function with given fields: botId
func (_m *StateMachineUsecase) GetByBot(botId uint) (*models.StateMachine, error) {
	ret := _m.Called(botId)

	var r0 *models.StateMachine
	if rf, ok := ret.Get(0).(func(uint) *models.StateMachine); ok {
		r0 = rf(botId)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.StateMachine)
		}
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(uint) error); ok {
		r1 = rf(botId)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// List provides a mock function with given fields: opt
func (_m *StateMachineUsecase) List(opt *ms_sharedmodels.ListOptions) (*[]models.StateMachine, ms_sharedmodels.Paginator, error) {
	ret := _m.Called(opt)

	var r0 *[]models.StateMachine
	if rf, ok := ret.Get(0).(func(*ms_sharedmodels.ListOptions) *[]models.StateMachine); ok {
		r0 = rf(opt)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*[]models.StateMachine)
		}
	}

	var r1 ms_sharedmodels.Paginator
	if rf, ok := ret.Get(1).(func(*ms_sharedmodels.ListOptions) ms_sharedmodels.Paginator); ok {
		r1 = rf(opt)
	} else {
		r1 = ret.Get(1).(ms_sharedmodels.Paginator)
	}

	var r2 error
	if rf, ok := ret.Get(2).(func(*ms_sharedmodels.ListOptions) error); ok {
		r2 = rf(opt)
	} else {
		r2 = ret.Error(2)
	}

	return r0, r1, r2
}

// Update provides a mock function with given fields: item
func (_m *StateMachineUsecase) Update(item *models.StateMachine) error {
	ret := _m.Called(item)

	var r0 error
	if rf, ok := ret.Get(0).(func(*models.StateMachine) error); ok {
		r0 = rf(item)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}
